<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\PlanilhaCotacao\Controllers; 

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class CentraisComprasController extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $dataSourceName = 'centraisCompras';
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
    }
    
    public function addProduto(DTO\Request $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();

        $query = 'SELECT * FROM QUANTCOTPROD WHERE CDFILIAL = :CDFILIAL AND CDPRODUTO = :CDPRODUTO';
	    $stmt = $this->con->prepare($query);
		$params = array(
		    "CDFILIAL" => $data[0]["CDFILIAL"],
    	    "CDPRODUTO" => $data[0]["CDPRODUTO"]
		);
		$stmt->execute($params);
		$a = $stmt->fetchAll();
        
        if (sizeof($a)==0) {
            $query = 'INSERT INTO QUANTCOTPROD(CDFILIAL, CDPRODUTO, VRQTDCOTACAO) VALUES(:CDFILIAL, :CDPRODUTO, :VRQTDCOTACAO)';
        	$stmt = $this->con->prepare($query);
        	$params = array(
        	    "CDFILIAL" => $data[0]["CDFILIAL"],
        	    "CDPRODUTO" => $data[0]["CDPRODUTO"],
        	    "VRQTDCOTACAO" => $data[0]["VRQTDCOTACAO"]
        	);
        	$stmt->execute($params);
        } else {
		    $response->setError(new Error("Produto já cadastrado.", 500));
        }
    }
    
    public function editProduto(DTO\Request $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();
        $query = 'UPDATE QUANTCOTPROD SET VRQTDCOTACAO =:VRQTDCOTACAO WHERE CDPRODUTO =:OLD_CDPRODUTO AND CDFILIAL =:OLD_CDFILIAL';
		$stmt = $this->con->prepare($query);
		$params = array(
		    "OLD_CDFILIAL" => $data[0]["CDFILIAL"],
		    "OLD_CDPRODUTO" => $data[0]["CDPRODUTO"],
		    "VRQTDCOTACAO" => $data[0]["VRQTDCOTACAO"]
		);
		$stmt->execute($params);
    }
    
    public function deleteProduto(DTO\Request $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();
        $query = 'DELETE FROM QUANTCOTPROD WHERE CDPRODUTO = :OLD_CDPRODUTO AND CDFILIAL = :OLD_CDFILIAL';
		$stmt = $this->con->prepare($query);
		$params = array(
		    "OLD_CDFILIAL" => $data[0]["CDFILIAL"],
		    "OLD_CDPRODUTO" => $data[0]["CDPRODUTO"]
		);
		$stmt->execute($params);
    }
}