<?php

namespace Teknisa\SUP\Modules\Cotacao\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use Teknisa\SUP\Util\SupUtilities;

class PedidoColetaService
{
    protected $connection;
	
    public function __construct($environment, $connection, SupUtilities $supUtilities) 
    {
        $this->environment = $environment;
        $this->connection = $connection;
        $this->supUtilities  = $supUtilities;
    }
    
    public function operadoresRelacionados($comprador){   
        $query = "SELECT CDOPERADOR, IDEXSENHCMPOPER, IDCOTCMPOPER, IDAPURCMPOPER, IDAFCMPOPER FROM COMPROPER WHERE CDCOMPRADOR = :P_CDCOMPRADOR AND NRORG = :P_NRORG";
        $params = [
            'P_CDCOMPRADOR' => $comprador,
            'P_NRORG'       => $this->environment->getNrorg()
        ];
        return $this->supUtilities->crud($query, $params);
    }
    
    public function getNmComprador($comprador){   
        $query = "SELECT CDOPERADOR || ' ' || NMOPERADOR AS COMPRADOR FROM OPERADOR WHERE CDOPERADOR = :P_CDCOMPRADOR AND NRORG = :P_NRORG";
        $params = [
            'P_CDCOMPRADOR' => $comprador,
            'P_NRORG'       => $this->environment->getNrorg()
        ];
        return $this->supUtilities->crud($query, $params);
    }
}
